<?php
//Defines:
error_reporting(0);
define('SMR63', 1);
session_start();
$start = microtime(true);
$time = time();
$dir = __DIR__;
$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
$domain = $protocol.$_SERVER['SERVER_NAME'];
$url = $domain.'/soomar63';
$referrer = parse_url($_SERVER['HTTP_REFERER'], PHP_URL_HOST);
$configpath = $dir.'/config.php';
$iplist = $dir.'/iplist/';

if (is_file($dir.'/version.txt')) {
	$ver = file_get_contents($dir.'/version.txt');
} else {$ver = '1.0';}

require_once $dir . '/captcha.php';

//Get config arrays:
$cfg = array();
if (is_file($configpath)) {require_once $configpath;}

$enable = $cfg['enable'];
if (!$enable) {$enable = "1";}
$secret = $cfg['secret'];
if (!$secret || $secret == 'SMR63') {$secret = rand(11111,55555);}
$language = $cfg['language'];
if (!$language) {$language = "en";}
$email = $cfg['email'];
$filelines = $cfg['filelines'];
if (!$filelines) {$filelines = "360";}
$allowtime = $cfg['allowtime'];
if (!$allowtime) {$allowtime = "1";}
$maxage = $cfg['maxage'];
if (!$maxage) {$maxage = "30";}
$countries = $cfg['countries'];
if (!$countries) {$countries = "US,DE,CA,GB,FR,NL,IR";}
$bots = $cfg['bots']; //Allowed bots
if (!$bots) {$bots = "";}

//$secret = date("Y-m-d H:i",$time);
if ($_POST['action'] == 'r' && $_POST["captcha"] == $_SESSION["srand"]) {$task = 'repair';}
elseif ($_POST['action'] == 'l' && $_POST['secret'] == $secret && $_POST["captcha"] == $_SESSION["srand"]) {$task = 'login';}

//Session:
$_SESSION["srand"] = rand(10000, 99999);
?>
<!DOCTYPE html>
<html lang="en-GB" dir="ltr">
<head>
<title>Soomar63: Admin Form</title>
<meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1.0, maximum-scale=2.0">
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta charset="utf-8" />
<meta name="keywords" content="" />
<meta name="description" content="" />
<meta name="generator" content="Soomar63" />
<meta name="robots" content="noindex,nofollow" />
<link rel="stylesheet" type="text/css" href="<?php echo $url."/assets/css/admin.css"; ?>" />
<link href="<?php echo $url."/assets/image/favicon.ico"; ?>" rel="shortcut icon" type="image/vnd.microsoft.icon" />
</head>
<body class="ltr">
<div id="content">
    <a href="<?php $url.'/admin.php'; ?>"><h1>Soomar63: Admin Form:</h1></a>
	
	<?php
	if ($task == 'repair') {//Repairing system:
		//Try to copy file to root
		set_time_limit(0);
		//File to save the contents to
		$fp = fopen ($dir.'/update.zip', 'w+');
		$updateurl = "https://soomar63.com/update/update.zip";
		//Here is the file we are downloading
		$ch = curl_init($updateurl);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		//Give curl the file pointer so that it can write to it
		curl_setopt($ch, CURLOPT_FILE, $fp);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		$data = curl_exec($ch);//get curl response
		//Done
		curl_close($ch);
		
		//Now unzip update.zip
		if (is_file($dir.'/update.zip')) {
			$zip = new ZipArchive;
			$res = $zip->open($dir.'/update.zip');
			if ($res === TRUE) {
				$zip->extractTo($dir);
				$zip->close();
				unlink($dir.'/update.zip');
			}
		}
		
		//Then delete all html cache files:
		$cachedir = $dir.'/cache/';
		array_map('unlink', glob( "$cachedir*.html"));
		
		echo '<pre>Soomar Security System repaired successfuly.</pre>';
	} elseif ($task == 'login') {
		//Login to admin:
		echo '<pre>You loged in to admin panel successfuly.</pre>';
	}
	?>
	
    <form id="admin" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]);?>" method="post">
		<label for="secret">Secret: <span>(find in configuration file)</span></label><br />
        <input type="text" id="secret" name="secret" value="<?php echo $_POST['secret']; ?>"><br />
		<?php if ($task == 'login') : ?>
		<label for="enable">Enable: <span>(enable or disable script)</span></label><br />
        <input type="text" id="enable" name="enable" value="<?php echo $enable; ?>"><br />
        <label for="language">Language: <span>(enter country ISO code, like: US)</span></label><br />
        <input type="text" id="language" name="language" value="<?php echo $language; ?>"><br />
		<label for="email">Email: <span>(enter email if you want to get notifications)</span></label><br />
        <input type="text" id="email" name="email" value="<?php echo $email; ?>"><br />
		<label for="filelines">Visits Limit: <span>(max visits by IP to send notification)</span></label><br />
        <input type="text" id="filelines" name="filelines" value="<?php echo $filelines; ?>"><br />
		<label for="allowtime">Allow Time: <span>(hours to temporary allow IP to visit)</span></label><br />
        <input type="text" id="allowtime" name="allowtime" value="<?php echo $allowtime; ?>"><br />
		<label for="maxage">Max Age: <span>(max IP age in days)</span></label><br />
        <input type="text" id="maxage" name="maxage" value="<?php echo $maxage; ?>"><br />
		<label for="countries">Countries: <span>(comma separated allowed countries)</span></label><br />
        <input type="text" id="countries" name="countries" value="<?php echo $countries; ?>"><br />
		<label for="bots">Bots: <span>(list of allowed bots, separate by comma)</span></label><br />
        <input type="text" id="bots" name="bots" value="<?php echo $bots; ?>"><br />
		<?php endif; ?>
        <label>Action:</label><br />
		<input type="radio" class="radio" id="l" name="action" value="l"><label for="l"><span>Login</span></label>
        <input type="radio" class="radio" id="r" name="action" value="r" checked="checked"><label for="r"><span>Repair</span></label>
        <br />
		
		<?php echo captcha($_SESSION["srand"]); ?><br />
		<label for="captcha">Captcha:</label><br />
		<input id="captcha" type="text" name="captcha" autocomplete="off" />
        <input class="btn" type="submit" value="Submit">
    </form>
    <p>Render Time: <?php $end = microtime(true);$rendertime = round($end - $start, 5);echo $rendertime; ?></p>
	<p><a href='https://soomar63.com' target='_blank'>Soomar63</a> v<?php echo $ver; ?></p>
</div>
</body>
</html>