<?php
//Defines:
error_reporting(0);
define('SMR63', 1);
session_start();
$start = microtime(true);
$time = time();
$dir = __DIR__;
$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
$domain = $protocol.$_SERVER['SERVER_NAME'];
$url = $domain.'/soomar63';
$referrer = parse_url($_SERVER['HTTP_REFERER'], PHP_URL_HOST);
$configpath = $dir.'/config.php';
$iplist = $dir.'/iplist/';

if (is_file($dir.'/version.txt')) {
	$ver = file_get_contents($dir.'/version.txt');
} else {$ver = '1.0';}

require_once $dir . '/captcha.php';

//Get config arrays:
$cfg = array();
if (is_file($configpath)) {require_once $configpath;}

//Get secret from config:
$secret = $cfg['secret'];
if (!$secret || $secret == 'SMR63') {$secret = rand(11111,55555);}

if ($_POST['secret'] == $secret && $_POST["captcha"] == $_SESSION["srand"]) {$execute = true;}

//Session:
$_SESSION["srand"] = rand(10000, 99999);
?>
<!DOCTYPE html>
<html lang="en-GB" dir="ltr">
<head>
<title>Soomar63: Manage Form</title>
<meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1.0, maximum-scale=2.0">
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta charset="utf-8" />
<meta name="keywords" content="" />
<meta name="description" content="" />
<meta name="generator" content="Soomar63" />
<meta name="robots" content="noindex,nofollow" />
<link rel="stylesheet" type="text/css" href="<?php echo $url."/assets/css/manage.css"; ?>" />
<link href="<?php echo $url."/assets/image/favicon.ico"; ?>" rel="shortcut icon" type="image/vnd.microsoft.icon" />
</head>
<body class="ltr">
<div id="content">
    <a href="<?php $url.'/manage.php'; ?>"><h1>Soomar63: Manage Form:</h1></a>
	
	<?php
	if ($execute) {
		//Get action choosed:
		if ($_POST['action']) {$action = $_POST['action'];}
		else {$action = 'c';}
		
		if ($action == 's') {$folder = 'Stopped';$raction = 'b';$rfolder = 'Blocked';}
		elseif ($action == 'b') {$folder = 'Blocked';$raction = 's';$rfolder = 'Stopped';}
		else {$folder = 'Allowed';$raction = 'bs';} //Needs modify
		if ($action == 'c' || $action == 'r') {$folder = null;}
		
		if ($_POST['ip']) {$ip = $_POST['ip'];}
		
		if ($ip) {
			$ip = trim($ip);
			$ipfile = $ip.'.ipf';
			
			$apath = $iplist.'a/';
			$bpath = $iplist.'b/';
			$spath = $iplist.'s/';
			
			if ($folder) {
				$actionpath = $iplist.$action;
				$ractionpath = $iplist.$raction;
			}
		} else {
			echo '<pre>No IP entered or IP is not valid IP.</pre>';
		}
		
		if ($actionpath) {

			$ippath = $actionpath.'/'.$ipfile;
			$rippath = $ractionpath.'/'.$ipfile;
			
			//Removes IP from another (b/s) directory:
			if (is_file($rippath)) {
				unlink($rippath);
				echo '<pre class="'.$rfolder.'">'.$ip.' was removed from '.$rfolder.' directory!</pre>';
			}
			
			if (is_file($ippath)) {
				$comment = file_get_contents($ippath);
				if ($comment) {
					$comment = "<pre class='Comment'>".$comment."</pre>";
				} else {
					$comment = "<pre class='Comment'>No comment added</pre>";
				}
				$ipmtime = date("Y-m-d H:i:s", filemtime($ippath));
				echo '<pre class="'.$folder.'">'.$ip.' was found in '.$folder.' directory!</pre><pre class="Date">Date modified: '.$ipmtime.' </pre>'.$comment;
			} else {
				//echo 'IP not exist.<br />';
				//Write the output
				if ($_POST['comment']) {
					$comment = $_POST['comment'];
				} else {
					$comment = '';
				}
				$write = fopen($ippath,"w");
				fwrite($write,$comment);
				fclose($write);
				
				if (is_file($ippath)) {
					echo '<pre class="'.$folder.'">'.$ip.' added to '.$folder.' directory!</pre>';
				}
			}
		
		} elseif ($action == 'r') {
			//Find and remove IP:
			if (is_file($apath.$ipfile)) {$found = true;unlink($apath.$ipfile);
			echo '<pre class="Allowed">'.$ip.' removed from Allowed directory.</pre>';}
			if (is_file($bpath.$ipfile)) {$found = true;unlink($bpath.$ipfile);
			echo '<pre class="Blocked">'.$ip.' removed from Blocked directory.</pre>';}
			if (is_file($spath.$ipfile)) {$found = true;unlink($spath.$ipfile);
			echo '<pre class="Stopped">'.$ip.' removed from Stopped directory.</pre>';}
			if (!$found) {echo '<pre class="Removed">'.$ip.' was not found in any directory.</pre>';}
		} else {
			//Check and find IP:
			if (is_file($apath.$ipfile)) {
			    $found = true;
			    $comment = file_get_contents($apath.$ipfile);if (!$comment) {$comment = "No comment added";}
			    $mtime = date("Y-m-d H:i:s", filemtime($apath.$ipfile));
			    echo '<pre class="Allowed">'.$ip.' was found in Allowed directory!</pre><pre class="Date">Date modified: '.$mtime.' </pre><pre class="Comment">'.$comment.'</pre>';
			}
			if (is_file($bpath.$ipfile)) {
			    $found = true;
			    $comment = file_get_contents($bpath.$ipfile);if (!$comment) {$comment = "No comment added";}
			    $mtime = date("Y-m-d H:i:s", filemtime($bpath.$ipfile));
			    echo '<pre class="Blocked">'.$ip.' was found in Blocked directory!</pre><pre class="Date">Date modified: '.$mtime.' </pre><pre class="Comment">'.$comment.'</pre>';
			}
			if (is_file($spath.$ipfile)) {
			    $found = true;
			    $comment = file_get_contents($spath.$ipfile);if (!$comment) {$comment = "No comment added";}
			    $mtime = date("Y-m-d H:i:s", filemtime($spath.$ipfile));
			    echo '<pre class="Stopped">'.$ip.' was found in Stopped directory!</pre><pre class="Date">Date modified: '.$mtime.' </pre><pre class="Comment">'.$comment.'</pre>';
			}
			if (!$found) {
			    echo '<pre class="Checked">'.$ip.' was not found in any directory!</pre>';
			}
		}
	}
	?>
	
    <form id="manage" action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]);?>" method="post">
        <label for="ip">IP*: <span>(v4 or v6)</span></label><br />
        <input type="text" id="ip" name="ip" value="<?php echo $_GET['ip']; ?>"><br />
        <label>Action:</label><br />
        <input type="radio" class="radio" id="c" name="action" value="c" checked="checked"><label for="c"><span>Check</span></label>
        <input type="radio" class="radio" id="s" name="action" value="s"><label for="s"><span>Stop</span></label>
        <input type="radio" class="radio" id="b" name="action" value="b"><label for="b"><span>Block</span></label>
        <input type="radio" class="radio" id="a" name="action" value="a"><label for="a"><span>Allow</span></label>
		<input type="radio" class="radio" id="r" name="action" value="r"><label for="r"><span>Remove</span></label>
        <br />
        <label for="secret">Secret: <span>(find in configuration file)</span></label><br />
        <input type="text" id="secret" name="secret" value="<?php echo $_POST['secret']; ?>"><br />
        <label for="comment">Comment: <span>(optional)</span></label><br />
        <textarea name="comment" form="manage"></textarea><br />
		<?php echo captcha($_SESSION["srand"]); ?><br />
		<label for="captcha">Captcha:</label><br />
		<input id="captcha" type="text" name="captcha" autocomplete="off" />
        <input class="btn" type="submit" value="Submit">
    </form>
    <p>Render Time: <?php $end = microtime(true);$rendertime = round($end - $start, 5);echo $rendertime; ?></p>
	<p><a href='https://soomar63.com' target='_blank'>Soomar63</a> v<?php echo $ver; ?></p>
</div>
</body>
</html>