<?php
	error_reporting(0);
	define('SMR63', 1);
	session_start();
    $start = microtime(true);
    
    $dir = __DIR__;
	$sname = $_SERVER['SERVER_NAME'];
	$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
    $domain = $protocol.$sname;
	$url = $domain.'/soomar63/';
	$languagedir = $dir.'/language/';
    $iplist = $dir.'/iplist/';
	$cache = $dir.'/cache/';
	
	if ($_POST['language']) {$_SESSION['language'] = $_POST['language'];}
	else {$_SESSION['language'] = 'en';}
	
	$language = $_SESSION['language'];
	
	if ($language == 'en') {$direction = 'ltr';}
	elseif ($language == 'fa') {$direction = 'rtl';}
	else {$direction = "ltr";}
	
	$languagefile = $languagedir.$language.'.php';
	if (is_file($languagefile)) {
		require_once($languagefile);
	} else {
		require_once($languagedir.'en.php');
	}
	
	if (is_file($dir.'/version.txt')) {
	$ver = file_get_contents($dir.'/version.txt');
	} else {$ver = '1.0';}
    
    //Get the client ip:
    $sclient  = @$_SERVER['HTTP_CLIENT_IP'];
    $sforward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
    $sremote  = $_SERVER['REMOTE_ADDR'];
    if(filter_var($sclient, FILTER_VALIDATE_IP)) {$uip = $sclient;}
    elseif(filter_var($sforward, FILTER_VALIDATE_IP)) {$uip = $sforward;}
    else {$uip = $sremote;}
    
    if ($_GET['page']) {$page = $_GET['page'];} else {$page = "1";}
    $cpath = $cache.$language.'-'.$page.'.html';
    
    $showcache = false;
    
    if (file_exists($cpath)) {
        if (time() > filemtime($cpath) + 3600) {//Cached page is old and should be delete:
            unlink($cpath);
        } else {
            $showcache = true;
        }
    }
    
    if ($showcache) {
        echo file_get_contents($cpath);
        $end = microtime(true);
	    $dtime = round(($end - $start), 5);
	    echo "<i><b>".$translate['GENERATED-IN'].":</b> ".$dtime." ".$translate['SECONDS']." (".$translate['CACHED'].")</i><br />";
        echo "<i><b>".$translate['YOUR-IP'].":</b> ".$uip."</i><br /><b><i><a href='https://soomar63.com' target='_blank'>Soomar63</a> v".$ver."</i></b></div></body></html>";
    } else {
    $output = "<!DOCTYPE html><html dir='".$direction."'><head><title>".$translate['REPORT-TITLE']."</title><meta name=\"robots\" content=\"noindex, nofollow\" /><meta name=\"viewport\" content=\"width=device-width, user-scalable=yes, initial-scale=1.0, maximum-scale=2.0\"><link rel=\"stylesheet\" type=\"text/css\" href=\"".$url."assets/css/report.css\" /><link href=\"".$url."assets/image/favicon.ico\" rel=\"shortcut icon\" type=\"image/vnd.microsoft.icon\" /></head><body class='".$direction."'>";
    
    $pmin = (($page-1)*50)+1;
    $pmax = $page*50;
    $duration = 0;
    $totalvisits = 0;
    $successvisits = 0;
    $failedvisits = 0;
    $state = "unknown";
    $size = 0;
    $firstvisit = time();
    $latestvisit = 0;
    
    //Tags:
    $isnew = '<span class="new">'.$translate['NEW'].'</span>';
    $isreturn = '<span class="return">'.$translate['RETURN'].'</span>';
    $isnormal = '<span class="normal">'.$translate['NORMAL'].'</span>';
    $isfast = '<span class="fast">'.$translate['FAST'].'</span>';
    $isblocked = '<span class="blocked">'.$translate['BLOCKED'].'</span>';
    $isstopped = '<span class="stopped">'.$translate['STOPPED'].'</span>';
    $isbot = '<span class="badbot">'.$translate['BOT'].'</span>';
    
    $ccodes = array('AF'=>'Afghanistan','AX'=>'Aland Islands','AL'=>'Albania','DZ'=>'Algeria','AS'=>'American Samoa','AD'=>'Andorra','AO'=>'Angola','AI'=>'Anguilla','AQ'=>'Antarctica','AG'=>'Antigua And Barbuda','AR'=>'Argentina','AM'=>'Armenia','AW'=>'Aruba','AU'=>'Australia','AT'=>'Austria',
'AZ'=>'Azerbaijan','BS'=>'Bahamas','BH'=>'Bahrain','BD'=>'Bangladesh','BB'=>'Barbados','BY'=>'Belarus','BE'=>'Belgium','BZ'=>'Belize','BJ'=>'Benin','BM'=>'Bermuda','BT'=>'Bhutan','BO'=>'Bolivia','BA'=>'Bosnia And Herzegovina','BW'=>'Botswana','BV'=>'Bouvet Island','BR'=>'Brazil','IO'=>'British Indian Ocean Territory',
'BN'=>'Brunei Darussalam','BG'=>'Bulgaria','BF'=>'Burkina Faso','BI'=>'Burundi','KH'=>'Cambodia','CM'=>'Cameroon','CA'=>'Canada','CV'=>'Cape Verde','KY'=>'Cayman Islands','CF'=>'Central African','TD'=>'Chad','CL'=>'Chile','CN'=>'China','CX'=>'Christmas Island','CC'=>'Cocos (Keeling) Islands','CO'=>'Colombia','KM'=>'Comoros',
'CG'=>'Congo','CD'=>'Congo, Democratic','CK'=>'Cook Islands','CR'=>'Costa Rica','CI'=>'Cote D Ivoire','HR'=>'Croatia','CU'=>'Cuba','CY'=>'Cyprus','CZ'=>'Czech','DK'=>'Denmark','DJ'=>'Djibouti','DM'=>'Dominica','DO'=>'Dominican','EC'=>'Ecuador','EG'=>'Egypt','SV'=>'El Salvador','GQ'=>'Equatorial Guinea','ER'=>'Eritrea',
'EE'=>'Estonia','ET'=>'Ethiopia','FK'=>'Falkland Islands (Malvinas)','FO'=>'Faroe Islands','FJ'=>'Fiji','FI'=>'Finland','FR'=>'France','GF'=>'French Guiana','PF'=>'French Polynesia','TF'=>'French Southern Territories','GA'=>'Gabon','GM'=>'Gambia','GE'=>'Georgia','DE'=>'Germany','GH'=>'Ghana','GI'=>'Gibraltar',
'GR'=>'Greece','GL'=>'Greenland','GD'=>'Grenada','GP'=>'Guadeloupe','GU'=>'Guam','GT'=>'Guatemala','GG'=>'Guernsey','GN'=>'Guinea','GW'=>'Guinea-Bissau','GY'=>'Guyana','HT'=>'Haiti','HM'=>'Heard Island & Mcdonald Islands','VA'=>'Holy See (Vatican City State)','HN'=>'Honduras','HK'=>'Hong Kong','HU'=>'Hungary',
'IS'=>'Iceland','IN'=>'India','ID'=>'Indonesia','IR'=>'Iran','IQ'=>'Iraq','IE'=>'Ireland','IM'=>'Isle Of Man','IL'=>'Israel','IT'=>'Italy','JM'=>'Jamaica','JP'=>'Japan','JE'=>'Jersey','JO'=>'Jordan','KZ'=>'Kazakhstan','KE'=>'Kenya','KI'=>'Kiribati','KR'=>'Korea','KW'=>'Kuwait','KG'=>'Kyrgyzstan','LA'=>'Lao People Democratic',
'LV'=>'Latvia','LB'=>'Lebanon','LS'=>'Lesotho','LR'=>'Liberia','LY'=>'Libyan Arab Jamahiriya','LI'=>'Liechtenstein','LT'=>'Lithuania','LU'=>'Luxembourg','MO'=>'Macao','MK'=>'Macedonia','MG'=>'Madagascar','MW'=>'Malawi','MY'=>'Malaysia','MV'=>'Maldives','ML'=>'Mali','MT'=>'Malta','MH'=>'Marshall Islands',
'MQ'=>'Martinique','MR'=>'Mauritania','MU'=>'Mauritius','YT'=>'Mayotte','MX'=>'Mexico','FM'=>'Micronesia, Federated States Of','MD'=>'Moldova','MC'=>'Monaco','MN'=>'Mongolia','ME'=>'Montenegro','MS'=>'Montserrat','MA'=>'Morocco','MZ'=>'Mozambique','MM'=>'Myanmar','NA'=>'Namibia','NR'=>'Nauru','NP'=>'Nepal',
'NL'=>'Netherlands','AN'=>'Netherlands Antilles','NC'=>'New Caledonia','NZ'=>'New Zealand','NI'=>'Nicaragua','NE'=>'Niger','NG'=>'Nigeria','NU'=>'Niue','NF'=>'Norfolk Island','MP'=>'Northern Mariana Islands','NO'=>'Norway','OM'=>'Oman','PK'=>'Pakistan','PW'=>'Palau','PS'=>'Palestinian Territory, Occupied','PA'=>'Panama','PG'=>'Papua New Guinea',
'PY'=>'Paraguay','PE'=>'Peru','PH'=>'Philippines','PN'=>'Pitcairn','PL'=>'Poland','PT'=>'Portugal','PR'=>'Puerto Rico','QA'=>'Qatar','RE'=>'Reunion','RO'=>'Romania','RU'=>'Russian Federation','RW'=>'Rwanda','BL'=>'Saint Barthelemy','SH'=>'Saint Helena','KN'=>'Saint Kitts And Nevis','LC'=>'Saint Lucia','MF'=>'Saint Martin','PM'=>'Saint Pierre And Miquelon',
'VC'=>'Saint Vincent And Grenadines','WS'=>'Samoa','SM'=>'San Marino','ST'=>'Sao Tome And Principe','SA'=>'Saudi Arabia','SN'=>'Senegal','RS'=>'Serbia','SC'=>'Seychelles','SL'=>'Sierra Leone','SG'=>'Singapore','SK'=>'Slovakia','SI'=>'Slovenia','SB'=>'Solomon Islands','SO'=>'Somalia','ZA'=>'South Africa','GS'=>'South Georgia And Sandwich Isl.',
'ES'=>'Spain','LK'=>'Sri Lanka','SD'=>'Sudan','SR'=>'Suriname','SJ'=>'Svalbard And Jan Mayen','SZ'=>'Swaziland','SE'=>'Sweden','CH'=>'Switzerland','SY'=>'Syrian Arab','TW'=>'Taiwan','TJ'=>'Tajikistan','TZ'=>'Tanzania','TH'=>'Thailand','TL'=>'Timor-Leste','TG'=>'Togo','TK'=>'Tokelau','TO'=>'Tonga','TT'=>'Trinidad And Tobago',
'TN'=>'Tunisia','TR'=>'Turkey','TM'=>'Turkmenistan','TC'=>'Turks And Caicos Islands','TV'=>'Tuvalu','UG'=>'Uganda','UA'=>'Ukraine','AE'=>'United Arab Emirates','GB'=>'United Kingdom','US'=>'United States','UM'=>'United States Outlying Islands','UY'=>'Uruguay','UZ'=>'Uzbekistan','VU'=>'Vanuatu','VE'=>'Venezuela',
'VN'=>'Viet Nam','VG'=>'Virgin Islands, British','VI'=>'Virgin Islands, U.S.','WF'=>'Wallis And Futuna','EH'=>'Western Sahara','YE'=>'Yemen','ZM'=>'Zambia','ZW'=>'Zimbabwe'
);
    
    $countries = array();
	$dircontents = array_diff(scandir($iplist, 0), array('.', '..', 'a', 'b', 's', 'index.php', 'error_log'));
	if ($dircontents) {
	
	$count = count($dircontents);
	$lis = '';
	$i = 1;
	
	foreach ($dircontents as $file) {
		$extension = pathinfo($file, PATHINFO_EXTENSION);
		if($extension === "ipf") {
			
			$fpath = $iplist.$file;
			$ip = explode('.',$file);
		    $ip = $ip[0].'.'.$ip[1].'.'.$ip[2].'.'.$ip[3];
		    
		    $filetime = filemtime($fpath);
		    if ($filetime < $firstvisit) {$firstvisit = $filetime;}
		    $content = file($fpath);
		    $filesize = filesize($fpath);
		    $size = $size + $filesize;
		    $rows = count($content);
		    $tags = '';
		    
		    //Method to determine visit duraion:
		    if ($rows > 2) {
		        $ftime = strtotime($content[1]);
			    $ltime = strtotime(end($content));
			    $duration = $ltime - $ftime;
			    
			    if ($duration > 86400) {$tags .= $isreturn;} else {$tags .= $isnew;}
				if ($duration < 0) {$duration = 0;}
		    } else {
		        $duration = 1;
		        $tags .= $isnew;
		    }
		    
		    $totalvisits = $totalvisits + $rows;
		    if ($content[0]) {
		        $detail = explode('|',$content[0]);$country = $detail[0];$status = $detail[2];
		        if ($detail[1] == 1) {$successvisits = $successvisits + $rows;$state = "successful";$statetxt = 'SUCCESSFUL-VISIT';} else {$failedvisits = $failedvisits + $rows;$state = "failed";$statetxt = 'FAILED-VISIT';}
		    } else {$country = "XX";$status = 'n';}
		    if (!in_array($country, $countries)) {$countries[] = $country;}
		    
		    $cname = $ccodes[$country];
		    if (!$cname) {$cname = $country;}
		    
		    $lastvisit = date("Y-m-d H:i",$filetime);
		    if ($filetime > $latestvisit) {$latestvisit = $filetime;}
		    
		    $viewtime = $duration/$rows;
		    if ($viewtime < 30) {$tags .= $isfast;$fast = true;} else {$tags .= $isnormal;}
		    if ($status == 'b' || is_file($iplist.'b/'.$file)) {$tags .= $isblocked;}
		    if ($status == 's' || is_file($iplist.'s/'.$file)) {$tags .= $isstopped;}
		    if ($fast && $state == "failed") {$tags .= $isbot;}
		    
		    if (($pmin <= $i) && ($i <= $pmax)) {
			$lis .= "<li class='".$state."'><strong><a rel='nofollow' target='_blank' href='".$url.'iplist/'.$file."'>".$ip."</a></strong> ".$tags."<br />
			".$rows." ".$translate[$statetxt]." ".$translate['FROM']." ".$cname." ".$translate['IN']." ".$duration." ".$translate['SEC']."<br />
			".$translate['LAST-VISIT'].": ".$lastvisit." ".$translate['SERVER-TIME']."
			<br /><a class='btn basic' rel='nofollow' target='_blank' href='https://www.abuseipdb.com/check/".$ip."'>AbuseIPDB</a><a class='btn basic' rel='nofollow' target='_blank' href='https://liveipmap.com/?ip=".$ip."'>LiveIPMap</a><a class='btn basic' rel='nofollow' target='_blank' href='https://www.ipalyzer.com/".$ip."'>IPalyzer</a><a class='btn basic' rel='nofollow' target='_blank' href='".$url.'manage.php?ip='.$ip."'>".$translate['MANAGE']."</a><a class='btn basic' rel='nofollow' target='_blank' href='https://soomar63.com/tools/report.php?sname=".$sname."&amp;ip=".$ip."'>".$translate['REPORT']."</a></li>";
		    }
		    $i = $i+1;
		}
	}
	
	} else {$lis .= $translate['NO-IPS']."<br />";}
	
	if ($count == 0) {
        $count = $totalvisits = $successvisits = 1;
        $failedvisits = 0;
		$latestvisit = $firstvisit;
    }
	
	$time = time();
    if (is_file($dir.'/license.txt')) {
	$expire = file_get_contents($dir.'/license.txt');
	} else {$expire = $time;}
    if ($expire > $time) {
	    $days = round(($expire - $time) / 86400);
	    $expire = '<span class="active">'.$translate['ACTIVE-FOR'].' '.$days.' '.$translate['DAYS'].'</span>';
	} else {
	    $days = round(($time - $expire) / 86400);
	    $expire = '<span class="expired">'.$translate['EXPIRED'].' '.$days.' '.$translate['DAYS'].' '.$translate['AGO'].'</span>';
	}
	
	$output .= "<a href='".$url."report.php'><h1>".$translate['REPORT-TITLE']."</h1></a>";
	$output .= "<form id='language' method='post' action='".htmlspecialchars($_SERVER["PHP_SELF"])."?page=".$page."'><select name='language' form='language' onchange='if (this.value != 0) {this.form.submit();}'><option value='0'>".$translate['SELECT-LANGUAGE']."</option><option value='fa'>فارسی</option><option value='en'>English</option></select></form>";
	$output .= "<div class='box'><strong>".$translate['SUMMARY'].":</strong><hr />";
	$output .= "<table>";
	$output .= "<tr><th>".$translate['LICENSE'].":</th><td>".$expire."</td></tr>";
	$output .= "<tr><th>".$translate['COUNTRIES'].":</th><td>".count($countries)."</td></tr>";
	$output .= "<tr><th>".$translate['TOTAL-VISITORS'].":</th><td>".$count."</td></tr>";
	$output .= "<tr><th>".$translate['TOTAL-VISITS'].":</th><td>".$totalvisits."</td></tr>";
	$output .= "<tr><th>".$translate['SUCCESSFUL-VISITS'].":</th><td>".$successvisits." <span class='black'>(".round(($successvisits*100)/$totalvisits, 2)."%)</span>"."</td></tr>";
	$output .= "<tr><th>".$translate['FAILED-VISITS'].":</th><td>".$failedvisits." <span class='black'>(".round(($failedvisits*100)/$totalvisits, 2)."%)</span>"."</td></tr>";
	$output .= "<tr><th>".$translate['VISITS-PER-VISITOR'].":</th><td>".round($totalvisits/$count, 2)."</td></tr>";
	$output .= "<tr><th>".$translate['VISITS-FROM'].":</th><td>".date("Y-m-d",$firstvisit)."</td></tr>";
	$output .= "<tr><th>".$translate['VISITS-TO'].":</th><td>".date("Y-m-d",$latestvisit)."</td></tr>";
	$output .= "</table>";
	
	$output .= "</div>";
	
    $output .= "<a class='btn success' rel='nofollow' target='_blank' href='".$url."iplist/a'>".$translate['ALLOWED-IPS']."</a> ";
	$output .= "<a class='btn warning' rel='nofollow' target='_blank' href='".$url."iplist/b'>".$translate['BLOCKED-IPS']."</a> ";
	$output .= "<a class='btn danger' rel='nofollow' target='_blank' href='".$url."iplist/s'>".$translate['STOPPED-IPS']."</a><br />";
	
	$output .= "<br /><div class='box'><strong>".$translate['TAG-TYPES'].":</strong><hr />";
	$output .= "<table>";
	$output .= "<tr><th>".$isnew."</th><td><span class='desc'>".$translate['IS-NEW-DESC']."</span></td></tr>";
	$output .= "<tr><th>".$isreturn."</th><td><span class='desc'>".$translate['IS-RETURN-DESC']."</span></td></tr>";
	$output .= "<tr><th>".$isnormal."</th><td><span class='desc'>".$translate['IS-NORMAL-DESC']."</span></td></tr>";
	$output .= "<tr><th>".$isfast."</th><td><span class='desc'>".$translate['IS-FAST-DESC']."</span></td></tr>";
	$output .= "<tr><th>".$isblocked."</th><td><span class='desc'>".$translate['IS-BLOCKED-DESC']."</span></td></tr>";
	$output .= "<tr><th>".$isstopped."</th><td><span class='desc'>".$translate['IS-STOPPED-DESC']."</span></td></tr>";
	$output .= "<tr><th>".$isbot."</th><td><span class='desc'>".$translate['IS-BOT-DESC']."</span></td></tr>";
	$output .= "</table>";
	$output .= "</div>";
	
	$output .= "<p>".$translate['LIST-OF-IPS']." <i>(".$translate['PAGE']." ".$page."):</i></p>";
	$output .= '<ul>';
	$output .= $lis;
	$output .= '</ul>';
	
	//Number of pages:
	$navs = round($count/50);
	if ($navs > 0) {
	    $output .= "<div class='nav'><i>".$translate['CURRENT-PAGE'].": ".$page."</i><br />";
	    for ($n = 1;$n <= $navs;$n++) {
	        $output .= "<a class='btn info' href='".$url."report.php/?page=".$n."'>".$n."</a>";
	    }
	    $output .= "</div>";
	}

	$size = round($size/1024);
	
	if ($size < 1) {
	    $size = "< 1";
	} elseif ($size > 5120) {//Send email if size in biger than 5 MB:
        
        $headers = "Content-Type: text/html; charset=UTF-8\r\n";
        $to = "security@soomar63.com";
        $subject = 'دیتابیس آی پی حجیم روی: ' . $domain;
        if ($language === "fa") {
            $style = '<style type="text/css">div {direction:rtl;text-align:right;font-family:tahoma;} .ltr {direction:ltr;text-align:left;} a {text-decoration:none;}</style>';
        } else {
            $style = '<style type="text/css">div {direction:ltr;text-align:left;font-family:tahoma;} .ltr {direction:ltr;text-align:left;} a {text-decoration:none;}</style>';
        }
        $message = '<div>تعداد آی پی ها روی دامنه '.$domain.' به '.$count.' عدد رسیده و مجموعا '.$size.' کیلوبایت فضا را استفاده نموده است. برای افزایش سرعت و همچنین صرفه جویی در فضای هاست، آی پی های قدیمی را حذف نمایید.<br /><a href="'.$url.'report.php" rel="nofollow" target="_blank">مشاهده گزارش</a></div>' . $style;
        $message = wordwrap($message,70);
        mail($to,$subject,$message,$headers);
	}
	
	$output .= "<div class='box'><i><b>".$translate['DATABASE-SIZE'].":</b> ".$size." ".$translate['KB']."</i><br />";
	$output .= "<i><b>".$translate['REPORT-DATE'].":</b> ".date("Y-m-d H:i:s",time())." ".$translate['SERVER-TIME']."</i><br />";
	
	if ($count > 10) {
    //Write the output
    $write = fopen($cpath,"w");
    fwrite($write,$output);
    fclose($write);
	}
    
    $end = microtime(true);
	$dtime = round(($end - $start), 5);
    
    echo $output;
    echo "<i><b>".$translate['GENERATED-IN'].":</b> ".$dtime." ".$translate['SECONDS']."</i><br />";
	echo "<i><b>".$translate['YOUR-IP'].":</b> ".$uip."</i><br /><b><i><a href='https://soomar63.com' target='_blank'>Soomar63</a> v".$ver."</i></b></div></body></html>";
}
?>