<?php
error_reporting(0);
define('SMR63', 1);
session_start();

function scheck() {
    //1. Define start:
	$start = microtime(true);
	$memstart = memory_get_usage();
	
	//2. Set default access to true:
    $saccess = true;
	
	//3. Set default IP:
    $sip = "127.0.0.1"; //Default local IP
	
	//4. Get the client IP:
    $sclient  = @$_SERVER['HTTP_CLIENT_IP'];
    $sforward = @$_SERVER['HTTP_X_FORWARDED_FOR'];
    $sremote  = $_SERVER['REMOTE_ADDR'];
    if(filter_var($sclient, FILTER_VALIDATE_IP)) {$sip = $sclient;}
    elseif(filter_var($sforward, FILTER_VALIDATE_IP)) {$sip = $sforward;}
    else {$sip = $sremote;}
	
	//5. Get the server IP
    $server = $_SERVER['SERVER_ADDR'];
	$isserver = false;
	if ($sip == $server) {$isserver = true;}
	
	//6. Check if it is Google or Bing IP range, So allow it immediately
	$goodbot = false;
    $sipex = explode('.', $sip);
    if (($sipex[0] === "66") && ($sipex[1] === "249")) {$goodbot = true;} //Googlebot
	elseif (($sipex[0] === "66") && ($sipex[1] === "102") && ($sipex[2] === "8")) {$goodbot = true;} //Googlebot
	if (($sipex[0] === "74") && ($sipex[1] === "125") && ($sipex[2] === "212")) {$goodbot = true;} //Googlebot
	elseif (($sipex[0] === "157") && ($sipex[1] === "55") && ($sipex[2] === "39")) {$goodbot = true;} //Bingbot
	if (($sipex[0] === "40") && ($sipex[1] === "77") && ($sipex[2] === "167")) {$goodbot = true;} //Bingbot
	elseif (($sipex[0] === "207") && ($sipex[1] === "46") && ($sipex[2] === "13")) {$goodbot = true;} //Bingbot
	if ($goodbot) {return $saccess;}
	
	//7. Prevent loading towise in json requests:
    if ($_GET['format'] === "json") {return $saccess;}
	
	//8. Always allow local site:
	if ($sip === "127.0.0.1") {return $saccess;}
	
	//9. Set variables and paths:
	$time = time();
    $dir = __DIR__;
	$configpath = $dir . '/config.php';
	$languagepath = $dir.'/language/';
	$iplist = $dir."/iplist/";
	$adir = $dir."/iplist/a/";
	$bdir = $dir."/iplist/b/";
	$sdir = $dir."/iplist/s/";
	$sname = $_SERVER['SERVER_NAME']; if (!$sname) {$sname = 'domain.com';}
	$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
    $domain = $protocol.$sname;
	
	//10. Get config arrays:
    $cfg = array();
    if (is_file($configpath)) {require_once $configpath;}
	
    $secret = $cfg['secret'];
    if (!$secret || $secret == 'SMR63') {$secret = rand(11111,55555);}
    $language = $cfg['language'];
    if (!$language) {$language = "en";}
    $email = $cfg['email'];
    $filelines = $cfg['filelines'];
    if (!$filelines) {$filelines = "360";}
    $allowtime = $cfg['allowtime'];
    if (!$allowtime) {$allowtime = "1";}
	$maxage = $cfg['maxage'];
    if (!$maxage) {$maxage = "30";}
    $countries = $cfg['countries'];
    if (!$countries) {$countries = "US,DE,CA,GB,FR,NL,IR";}
	$countries = str_replace(' ', '', $countries);
    $countries = explode(',', $countries);
	$bots = $cfg['bots']; //Allowed bots
	if ($bots) {$bots = explode(',', $bots);} else {$bots = array();}
	
	//11. Get user agent:
	$agent = $_SERVER['HTTP_USER_AGENT'];
	if (!$agent) {$agent = 'NoAgent';}
	
	//12. Check badbots: from v4.34 (Adsbot, NoAgent removed from list)
	$badbot = false;
	$signatures = array("AhrefsBot","Applebot","Amazonbot","AwarioSmartBot","Baiduspider","Barkrowler","BLEXBot","CCBot","CensysInspect","clark-crawler","DataForSeoBot","DotBot","DuckDuckBot","facebookexternalhit","ForceFeedBot","IndeedBot","IonCrawl","KomodiaBot","MegaIndex","MJ12bot","montastic-monitor","newspaper","NE Crawler","Nicecrawler","panscient","PetalBot","Pinterestbot","Python","python-requests","Punkspider","Qwantify","Re-re Studio","RU_Bot","scrapy","SemanticJuice","SemrushBot","serpstatbot","SEOkicks","SeznamBot","SiteCheckerBotCrawler","Siteliner","SiteLockSpider","SMTBot","Sogou","StatusCake","StormCrawler","SurdotlyBot","The Knowledge AI","ThinkChaos","trendictionbot","Twitterbot","UptimeRobot","VelenPublicWebCrawler","XML-Sitemaps","YandexBot","ZoominfoBot");
	foreach ($signatures as $sign) {
		if (strpos($agent, $sign) !== false && !in_array($sign, $bots) && !$isserver) { // && !$isserver added from v4.32
			$badbot = true;
			
			if ($badbot && $sip != $server) {//Redirect badbots: from v4.38
				header("HTTP/1.1 301 Moved Permanently");
				header("Location: http://".$sip);
				die();
			}
		}
	}
	
	$signatures = array("Googlebot","APIs-Google","AdsBot","DuplexWeb-Google","FeedFetcher-Google","Google-Read-Aloud","googleweblight","Mediapartners-Google","Storebot-Google","Bingbot","Total Crawler", "RSSeo! Crawler");
	foreach ($signatures as $sign) {
		if (strpos($agent, $sign) !== false) {
			$goodbot = true;
		}
	}
	
	if ($goodbot) {return $saccess;}
	
	//13. Check session time and visit_counter: from v4.35
	if (!isset($_SESSION['time'])) {$_SESSION['time'] = $time;}
	if (!isset($_SESSION['visit_counter'])) {$_SESSION['visit_counter'] = 1;}
	$session_duration = $time - $_SESSION['time'];
	if ($session_duration > 3600) { //Reset $_SESSION['visit_counter']
		$_SESSION['visit_counter'] = 1;
	}
	
	//14. Slow down visits:
	if ($_SESSION['visit_counter'] > 180 && !$goodbot) {
		$pause = ($_SESSION['visit_counter'] / 5) * 1000000;
		usleep($pause);
	}
	
	//15. Sending data to server; If is badbot, send data to server only once:
	//if (!$badbot || !isset($_SESSION['return'])) {
	if (!isset($_SESSION['return'])) { //Changed from v4.37
		
		//Shortening Agent:
		if ($agent && $agent != 'NoAgent') {
		$regex = "@(https?://([-\w\.]+[-\w])+(:\d+)?(/([\w/_\.#-]*(\?\S+)?[^\.\s])?)?)@";
		$sagent = preg_replace($regex, '', $agent);
		$regex = "/[^@\s]*@[^@\s]*\.[^@\s]*/";
		$sagent = preg_replace($regex, '', $sagent);
		$sagent = preg_replace('/[0-9]+/', '', $sagent);
		$chars = array("AppleWebKit","Intel Mac OS X","KHTML","Version","http://","www.","like Gecko"," ",".","_","/",",","(",")",";",":","+","-");
		foreach ($chars as $char) {$sagent = str_replace($char,'',$sagent);}
		$sagent = strtolower($sagent);
		} else {$sagent = "noagent";}
	
		//Create data structure: Domain|Time|IP|Agent
		$data = base64_encode($sname.'|'.$time.'|'.$sip.'|'.$sagent);
		
		//Send data to server using init curl object:
		$ch = curl_init();
		//Define options
		$optArray = array(
			CURLOPT_URL => 'https://soomar63.com/sapi.php?data='.$data,
			CURLOPT_RETURNTRANSFER => true
		);
		//Apply those options
		curl_setopt_array($ch, $optArray);
		//Execute request and get response
		$return = curl_exec($ch);
		
		//Put $return in session:
		$_SESSION['return'] = $return;
	} else {
		$return = $_SESSION['return'];
	}
	
	$return = base64_decode($return);
	$return = explode('|', $return);
	
	//16. Get returned structure data: Country|Status|Delay|Version|Extra|Expire
	$expire = $return[5];
	if (!$expire) {$expire = $time;}
	
	if (!is_file($dir.'/license.txt')) {
	    $write = fopen($dir.'/license.txt',"w");fwrite($write,$expire.'|'.$time);fclose($write);
	} else {
	    $license = file_get_contents($dir.'/license.txt');
		$license = explode('|', $license);
	    if ($expire != $license[0]) {
	        file_put_contents($dir.'/license.txt', $expire.'|'.$time);
	    }
	}
	
	if ($expire > $time) {
	    $days = round(($expire - $time) / 86400);
	    $expire = 'License is active for '.$days.' day(s)';
	} else {
	    $days = round(($time - $expire) / 86400);
	    $expire = 'License is expired '.$days.' day(s) ago';
		
		//Send email every day:
		if (!is_file($dir.'/license.txt')) {
			$license = file_get_contents($dir.'/license.txt');
			$license = explode('|', $license);
			if ($time > ($license[1] + 86400)) {
				//Send mail here:
				if ($email) {
					$headers = "Content-Type: text/html; charset=UTF-8\r\n";
					$to = $email;
					$subject = 'License is expiring in '.$days;
					if ($language === "fa") {
						$style = '<style type="text/css">div{direction:rtl;text-align:right;font-family:tahoma;}.ltr{direction:ltr;text-align:left;}a.btn {line-height:25px;padding:3px 5px;text-decoration:none;border-radius:5px;color:#fff;}a.btn-primary{background:#007BFF;}a.btn-success{background:#28A745;}a.btn-info{background:#17A2B8;}a.btn-danger{background:#DC3545;}a.btn-warning{background:#FFC107;}</style>';
					} else {
						$style = '<style type="text/css">div{direction:ltr;text-align:left;font-family:tahoma;}.ltr{direction:ltr;text-align:left;}a.btn {line-height:25px;padding:3px 5px;text-decoration:none;border-radius:5px;color:#fff;}a.btn-primary{background:#007BFF;}a.btn-success{background:#28A745;}a.btn-info{background:#17A2B8;}a.btn-danger{background:#DC3545;}a.btn-warning{background:#FFC107;}</style>';
					}
					
					//Calculate render time:
					$end = microtime(true);
					$rendertime = round($end - $start, 2);
					$memhere = round((memory_get_usage() - $memstart)/1024);
					
					$message = '<div>License of Soomar Security System will expire in '.$days.'. Renew your license to keep your website safe and fast.</div><div class="ltr">Render Time: '.$rendertime.' second(s) | Memory usage: '.$memhere.' Kb<br />Soomar Security System (v'.$ver.')</div>' . $style;
					$message = wordwrap($message,70);
					mail($to,$subject,$message,$headers);
				}
				
				//Update license file:
				file_put_contents($dir.'/license.txt', $license[0].'|'.$time);
			}
		}
		
		$saccess = true;return $saccess;
	}
	$extra = $return[4]; //Extra returned from server
	$rver = $return[3]; //Version returned from server
	if (!$rver) {$rver = '1.0';}
	$delay = $return[2]; //Delay returned from server
	if (!$delay) {$delay = '0.0';}
	$status = $return[1]; //Status returned from server
	if (!$status) {$status = 'n';}
    $ccountry = explode('"',$return[0]); //Country returned from server
    $ccountry = $ccountry[0];
    if (strlen($ccountry) != 2) {$ccountry = "XX";}
	
	//17. Get version
	if (is_file($dir.'/version.txt')) {
		$ver = file_get_contents($dir.'/version.txt');
	} else {$ver = '1.0';}
	
	//18. Check version:
	if ($rver > $ver) { //There is new version available:
		//Try to copy file to root
		set_time_limit(0);
		//File to save the contents to
		$fp = fopen ($dir.'/update.zip', 'w+');
		$updateurl = "https://soomar63.com/update/update.zip";
		//Here is the file we are downloading
		$ch = curl_init($updateurl);
		curl_setopt($ch, CURLOPT_TIMEOUT, 5);
		//Give curl the file pointer so that it can write to it
		curl_setopt($ch, CURLOPT_FILE, $fp);
		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
		$data = curl_exec($ch);//get curl response
		//Done
		curl_close($ch);
		
		//Now unzip update.zip
		if (is_file($dir.'/update.zip')) {
			$zip = new ZipArchive;
			$res = $zip->open($dir.'/update.zip');
			if ($res === TRUE) {
				$zip->extractTo($dir);
				$zip->close();
				unlink($dir.'/update.zip');
			}
		}
		
		//Check and run patch.php
		if (is_file($dir.'/patch.php')) {
			require_once $dir . '/patch.php';
			unlink($dir.'/patch.php');
		}
		
		//Then delete all html cache files:
		$cachedir = $dir.'/cache/';
		array_map('unlink', glob( "$cachedir*.html"));
	}
	
	//19. Return if disabled:
	$disable = $cfg['disable'];
	if (!$disable) {$disable = "0";}
	if ($disable == "1") {return $saccess;}

	//20. Set IP file paths:
	$ipfile = $sip.'.ipf';
	$file = $iplist.$ipfile;
	
	//21. Check folders:
	$in_a = false;if (is_file($adir.$ipfile)) {$in_a = true;
	$temp = file_get_contents($adir.$ipfile);
		if ($temp == "Temporary") {
			$allowtime = $allowtime * 3600; //Convert allow time from h to s
			$temptime = filemtime($adir.$ipfile);
			if (($time - $temptime) > $allowtime) {
				unlink($adir.$ipfile);
				$in_a = false;
			}
		}
	}
	$in_b = false;if (is_file($bdir.$ipfile)) {$in_b = true;}
	$in_s = false;if (is_file($sdir.$ipfile)) {$in_s = true;}
    
    //22. Get translated texts:
    if (is_file($languagepath.$language.'.php')) {
        require_once $languagepath.$language.'.php';
    } else {
        require_once $languagepath.'en.php';
    }
	
	//23. Create and check IP file:
	if (is_file($file)) {//Write the time to existing IP file:
		$ftime = PHP_EOL.date("Y-m-d H:i:s",$time);
		$write = fopen($file,"a");
		fwrite($write,$ftime);
		fclose($write);
	}
	else {//Create IP file
		$content = $ccountry.'|'.'1'.'|'.$status.'|'.$delay.'|'.$agent; //Access is 1 by default
		$write = fopen($file,"w");
		fwrite($write,$content);
		fclose($write);
	} //Now IP file is always exist
	
	//24. If file size is big, So there is many visit from this IP, So send email:
	$lines = file($file);
	$count = count($lines);
    if ($count > $filelines) {
		//Now read IP.ipf file and check first and last time:
		$ftime = strtotime($lines[1]);
		$ltime = strtotime(end($lines));
		$dtime = $ltime - $ftime;
		
		$firstline = $lines[0];
		$headers = "Content-Type: text/html; charset=UTF-8\r\n";
		if ($email) {
			$to = $email;
			$headers .= "Bcc: security@soomar63.com\r\n";
		} else {
			$to = "security@soomar63.com";
		}
		$subject = $sip . ' ('. $ccountry . '|' . $status . ') ' . $translate["VISITS-ON"] . $sname;
		if ($language === "fa") {
			$style = '<style type="text/css">div{direction:rtl;text-align:right;font-family:tahoma;}.ltr{direction:ltr;text-align:left;}a.btn {line-height:25px;padding:3px 5px;text-decoration:none;border-radius:5px;color:#fff;}a.btn-primary{background:#007BFF;}a.btn-success{background:#28A745;}a.btn-info{background:#17A2B8;}a.btn-danger{background:#DC3545;}a.btn-warning{background:#FFC107;}</style>';
		} else {
			$style = '<style type="text/css">div{direction:ltr;text-align:left;font-family:tahoma;}.ltr{direction:ltr;text-align:left;}a.btn {line-height:25px;padding:3px 5px;text-decoration:none;border-radius:5px;color:#fff;}a.btn-primary{background:#007BFF;}a.btn-success{background:#28A745;}a.btn-info{background:#17A2B8;}a.btn-danger{background:#DC3545;}a.btn-warning{background:#FFC107;}</style>';
		}
		
		//Calculate render time:
		$end = microtime(true);
		$rendertime = round($end - $start, 2);
		$memhere = round((memory_get_usage() - $memstart)/1024);
		
		$message = '<div>'.$count . $translate["VISITS-BY"] . $sip . $translate["ON"] . $sname . $translate["IN"] . $dtime . $translate["SECONDS"] . '.<br /><a class="btn btn-primary" rel="nofollow" target="_blank" href="'.$domain.'/soomar63/iplist/'.$sip.'.ipf">'.$translate["VIEW-LOG"].'</a><br /><a  class="btn btn-success" href="' . $domain . '/soomar63/report.php">'.$translate["VIEW-ALL"].'</a><br /><a class="btn btn-warning" href="' . $domain . '/soomar63/iplist/b">'.$translate["VIEW-BLOCKED"].'</a><br />'.$translate["CHECK-IP"].'</div><div class="ltr"><a class="btn btn-info" rel="nofollow" target="_blank" href="https://www.abuseipdb.com/check/' . $sip . '">AbuseIPDB</a><br /><a class="btn btn-info" rel="nofollow" target="_blank" href="https://liveipmap.com/?ip=' . $sip . '">LiveIPMap</a><br /><a class="btn btn-info" rel="nofollow" target="_blank" href="https://www.ipalyzer.com/' . $sip . '">IPalyzer</a></div><div>'.$translate["DETAILS"].'</div><div class="ltr">' . $firstline.'</div><a class="btn btn-warning" rel="nofollow" target="_blank" href="' . $domain . '/soomar63/manage.php?ip='.$sip.'">Manage IP</a> <a class="btn btn-danger" rel="nofollow" target="_blank" href="https://soomar63.com/tools/report.php?sname='.$sname.'&amp;ip='.$sip.'">Report IP</a><br /><div class="ltr">Render Time: '.$rendertime.' second(s) | Memory usage: '.$memhere.' Kb<br />Soomar Security System (v'.$ver.')</div>' . $style;
		$message = wordwrap($message,70);
		mail($to,$subject,$message,$headers);
		
		//Truncate IP file after send email:
		file_put_contents($file, $firstline.date("Y-m-d H:i:s",$time));
	}
	
	//25. Delay if delay != 0:
	if ($delay != '0.0') {$delay = $delay * 1000000; usleep($delay);}
	
	//26. Stop all s status:
	if ($status == 's' && !$in_a) {$stopit = true;}
	elseif ($in_s && !$in_a) {$stopit = true;}
	elseif ($badbot && !$in_a) {
		$stopit = true;
		//break; //Commented from v4.36
	}
	
    if ($stopit && $delay == '0.0') { // $delay == '0.0' added from 4.33
		//Update IP file:
		$update = file_get_contents($file);
		$update = str_replace('|1|', '|0|', $update);
		$update = str_replace('|n|', '|s|', $update);
		$update = str_replace('|a|', '|s|', $update);
		$update = str_replace('|b|', '|s|', $update);
		file_put_contents($file, $update);
			
		//Calculate render time:
		$end = microtime(true);
		$rendertime = round($end - $start, 2);
		$memhere = round((memory_get_usage() - $memstart)/1024);
    
echo '<!DOCTYPE html>
<html  lang="fa-IR" dir="rtl">
<head>
<meta name="title" content="Soomar63 Security System" />
<meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1.0, maximum-scale=2.0">
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta charset="utf-8" />
<meta name="generator" content="Soomar63" />
<title>Soomar63 Security System</title>
<link href=\"http://".$url."assets/image/favicon.ico\" rel=\"shortcut icon\" type=\"image/vnd.microsoft.icon\" />
</head>
<body><div id="box">
<div id="title">وبسایت تحت نگهداری است</div>
<div class="small">Website is under maintenance</div>
<hr />
<div class="small">Is this your IP? Send request to unleash it: <a rel="nofollow" target="_blank" href="https://soomar63.com/tools/request.php?sname='.$sname.'&amp;ip='.$sip.'">Request Unleash</a></div>
<div class="small">Render time: '.$rendertime.' second(s) | Memory usage: '.$memhere.' Kb</div>
<div class="small">'.$expire.' | <a target="_blank" href="https://soomar63.com">Soomar63</a> v'.$ver.'</div>
</div>
<style>
body {font-family:Tahoma;margin:0;padding:0;text-align:center;background:#f9f9f9;line-height:25px;}
a {text-decoration:none;}
#box {max-width:500px;margin:0 auto;}
#title {font-size:22px;color:#666;margin:30px 0 20px 0;}
.small {font-family:"Courier New", monospace;font-size:12px;}
</style>
</body>
</html>';
	$saccess = false;return $saccess;
    }
	
	//27. Block all b status:
	if ($status == 'b' && !$in_a) {$blockit = true;}
	elseif ($in_b && !$in_a) {$blockit = true;}
	else {//Check if country is not in allowed countries
		if (!in_array($ccountry, $countries) && !$isserver && !$in_a) {$blockit = true;}
	}
	
	if ($blockit && $delay == '0.0') { // $delay == '0.0' added from 4.33
		//Check answer:
		if (isset($_POST["answer"])) {$answer = $_POST["answer"];} else {$answer = 1;}
        if ($answer == $_SESSION["srand"]) {//The given answer is correct, So return saccess true.
		
			unset($_SESSION["srand"]);
			
			//Unlink from b directory:
			//if (is_file($bdir.$ipfile)) {
            //    unlink($bdir.$ipfile);
            //}
			
			//Update IP file:
			$update = file_get_contents($file);
			$update = str_replace('|0|', '|1|', $update);
			$update = str_replace('|b|', '|n|', $update);
			file_put_contents($file, $update);
			
			//Write IP to a folder:
			$apath = $adir.$ipfile;
			$write = fopen($apath,"w");
			fwrite($write,'Temporary');
			fclose($write);
			
            return $saccess;
			
        } else {//The answer is empty or incorrect, So show the answer form:
			
			//Update IP file:
			$update = file_get_contents($file);
			$update = str_replace('|1|', '|0|', $update);
			$update = str_replace('|n|', '|b|', $update);
			$update = str_replace('|a|', '|b|', $update);
			$update = str_replace('|s|', '|b|', $update);
			file_put_contents($file, $update);
		
			$_SESSION["srand"] = rand(10000, 99999);
			
			require_once $dir . '/captcha.php';
			
			//Calculate render time:
			$end = microtime(true);
			$rendertime = round($end - $start, 2);
			$memhere = round((memory_get_usage() - $memstart)/1024);

echo '<!DOCTYPE html>
<html  lang="fa-IR" dir="rtl">
<head>
<meta name="title" content="Soomar63 Security System" />
<meta name="viewport" content="width=device-width, user-scalable=yes, initial-scale=1.0, maximum-scale=2.0">
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<meta charset="utf-8" />
<meta name="generator" content="Soomar63" />
<title>Soomar63 Security System</title>
<link href=\"http://".$url."assets/image/favicon.ico\" rel=\"shortcut icon\" type=\"image/vnd.microsoft.icon\" />
</head>
<body><div id="box">
<div id="title">کاربر گرامی خوش آمدید</div>
<div class="small">Your IP ('.$ccountry.'): '.$sip.'</div>
<div class="small">Date: '.date("Y-m-d H:i:s",time()).'</div>
<hr />
<div id="fadesc">احتمالا شما با استفاده از آی پی غیرمجاز و یا فیلترشکن وارد سایت شده اید. به دلایل امنیتی، برای ورود به سایت، کد امنیتی زیر را وارد نمایید:</div>
<div id="endesc">You are using unusual IP or using VPN to view this website; So, please enter the security code bellow:</div>
'.captcha($_SESSION["srand"]).'<form action="'.htmlspecialchars($_SERVER["PHP_SELF"]).'" method="post">
درج کد امنیتی:<br /><span>:Type the code here</span><br /><input id="answer" type="text" name="answer" autocomplete="off" /><br />
<input id="submit" type="submit" value="ورود Enter" />
</form>
<hr />
<div class="small">Is this your IP? Send request to unblock it: <a rel="nofollow" target="_blank" href="https://soomar63.com/tools/request.php?sname='.$sname.'&amp;ip='.$sip.'">Request Unblock</a></div>
<div class="small">Render time: '.$rendertime.' second(s) | Memory usage: '.$memhere.' Kb</div>
<div class="small">'.$expire.' | <a target="_blank" href="https://soomar63.com">Soomar63</a> v'.$ver.'</div>
</div>
<style>
    body {font-family:Tahoma;margin:0;padding:0;font-size:22px;text-align:center;background:#f9f9f9;line-height:25px;}
	a {text-decoration:none;}
    span {font-size:13px;}
    #box {max-width:500px;margin:0 auto;}
	#title {font-size:22px;color:#666;margin:30px 0 20px 0;}
	#fadesc {font-size:12px;text-align:justify;padding:0 3px;}
	#endesc {direction:ltr; font-size:12px;text-align:justify;padding:0 5px;}
    #answer {width:300px;height:45px;border-radius:5px;background:#333;text-align:center;letter-spacing:9px;font-size:24px;line-height:45px;color:#ff0;}
    #submit {font-size:22px;width:310px;height:40px;margin-top:10px;}
	.small {font-family:"Courier New", monospace;font-size:12px;}
</style>
</body>
</html>';
	$saccess = false;return $saccess;
        }
	}

return $saccess;
}
?>